CFLAGS = -model far  -opt on
# debug options: -mbg on -sym on
# look elsewhere for flex.skel: -d DEFAULT_SKELETON_FILE='"Prog:flex.skel"'

OBJECTS = 
		ccl.c.o 
		dfa.c.o 
		ecs.c.o 
		gen.c.o 
		misc.c.o 
		nfa.c.o 
		parse.c.o 
		scan.c.o 
		sym.c.o 
		tblcmp.c.o 
		yylex.c.o 
		main.c.o


flex  {OBJECTS}
	Link -model far -d -c 'MPS ' -t MPST 
		{OBJECTS} 
		#"{CLibraries}"CSANELib.o 
		#"{CLibraries}"Math.o 
		#"{CLibraries}"Complex.o 
		"{CLibraries}"StdClib.o 
		"{Libraries}"Stubs.o 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		#"{Libraries}"ToolLibs.o 
		-o flex
		
ccl.c.o  ccl.c flexdef.h parse.h
	 C {CFLAGS}  ccl.c
dfa.c.o  dfa.c flexdef.h parse.h
	 C {CFLAGS}  dfa.c
ecs.c.o  ecs.c flexdef.h parse.h
	 C {CFLAGS}  ecs.c
gen.c.o  gen.c flexdef.h parse.h
	 C {CFLAGS}  gen.c
main.c.o  main.c flexdef.h parse.h
	 C {CFLAGS}  main.c
misc.c.o  misc.c flexdef.h parse.h
	 C {CFLAGS}  misc.c
nfa.c.o  nfa.c flexdef.h parse.h
	 C {CFLAGS}  nfa.c
parse.c.o  parse.c flexdef.h parse.h
	 C {CFLAGS}  parse.c
scan.c.o  scan.c flexdef.h parse.h
	 C {CFLAGS}  scan.c
sym.c.o  sym.c flexdef.h parse.h
	 C {CFLAGS}  sym.c
tblcmp.c.o  tblcmp.c flexdef.h parse.h
	 C {CFLAGS}  tblcmp.c
yylex.c.o  yylex.c flexdef.h parse.h
	 C {CFLAGS}  yylex.c
parse.c parse.h  parse.y
	 yacc -d parse.y
	 Rename y.tab.c parse.c
	 Rename y.tab.h parse.h
